%global rocm_release 5.5
%global rocm_patch 1
%global rocm_version %{rocm_release}.%{rocm_patch}

Name:           hipcc
Version:        %{rocm_version}
Release:        1%{?dist}
Summary:        HIP compiler driver
Url:            https://github.com/ROCm-Developer-Tools/HIPCC
License:        MIT
Source0:        https://github.com/ROCm-Developer-Tools/HIPCC/archive/refs/tags/rocm-%{version}.tar.gz#/%{name}-%{version}.tar.gz

#Upstream fixes:
# HIPCC is very new, so cmake was incomplete when 5.5 was tagged:
Patch1:         https://github.com/ROCm-Developer-Tools/HIPCC/commit/b031ca07678d0be4535a97fae3a283345a37b4cc.patch
Patch2:         https://github.com/ROCm-Developer-Tools/HIPCC/commit/d4edc0e73b8275e9be41012cd0012ca3f6001c42.patch
# Remove use of mktemp:
Patch3:         https://github.com/ROCm-Developer-Tools/HIPCC/commit/ff695e430e07b12e8c6808ababee2254917e6b04.patch

# HIPCC fix for Fedora:
# https://github.com/ROCm-Developer-Tools/HIPCC/pull/83
Patch4:         0001-Improve-HIP_CLANG_PATH-detection.patch

BuildRequires:  cmake
BuildRequires:  gcc-c++

# This is for the "hipcc" script, which will be moved here in the future, see:
#https://github.com/ROCm-Developer-Tools/HIPCC/commit/043f3a9fa35153a0b6930bab72bc49d5ed22504a
Requires:       hip >= %{version}

Requires:       clang
# 16.2 has an important fix for hipcc to work out of the box:
Requires:       rocm-device-libs >= 16.2

# This package depends on "hip" which is only built on these arches right now:
ExclusiveArch:  x86_64 aarch64 ppc64le

%description
hipcc is a compiler driver utility that will call clang or nvcc, depending on
target, and pass the appropriate include and library options for the target
compiler and HIP infrastructure.

hipcc will pass-through options to the target compiler. The tools calling hipcc
must ensure the compiler options are appropriate for the target compiler.

%prep
%autosetup -p1 -n HIPCC-rocm-%{version}

# ROCm upstream uses /opt/rocm/hsa for rocm-runtime, but Fedora uses /usr
# Don't include it  since /usr/include is already included
sed -i '/" -isystem " + hsaPath + "\/include"/d' src/hipBin_amd.h

%build
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo
%cmake_build

%install
%cmake_install

%files
%license LICENSE.txt
%doc README.md
%{_bindir}/hipcc.bin
%{_bindir}/hipconfig.bin
#Duplicated files:
%exclude %{_docdir}/hipcc/LICENSE.txt

%changelog
* Wed Jun 07 2023 Jeremy Newton <alexjnewt at hotmail dot com> - 5.5.1-1
- Initial package
